#include once "ToT.bi"
screenres (FeldBreit+2)*HexRadius*3/2+HexXplus+FeldXplus, (FeldHoch+2)*HexGroesse+HexYplus, 32
randomize

' Bilder laden
for i as integer = 0 to 10
  img(i) = imagecreate(20, 20, 0)
next
bload "img" slash "haus.bmp", img(Feldart.Haus)
bload "img" slash "mine.bmp", img(Feldart.Mine)
for i as integer = 0 to 5
  bload "img" slash "garten" & i & ".bmp", img(Feldart.Garten0 + i)
next
bload "img" slash "arbeiter1.bmp", img(Feldart.Arbeiter1)
bload "img" slash "arbeiter2.bmp", img(Feldart.Arbeiter2)
hintergrund = imagecreate((FeldBreit+2)*HexRadius*3/2+HexXplus-10, (FeldHoch+2)*HexGroesse+HexYplus)

' aktuelle Spielinformationen
dim as TypSpielopt opt, gegner

feld(20, 12) = type<TypFeld>(Feldart.Mine, 0)
with opt
  ' Spieleinstellungen und Ziele
  .typ              = 1
  .fuellZiel        = 60
  .fuellAktuell     = 0
  .zeit             = 550
  .dollar           = 20
  .suess            = 80
  .inaktivFalle     = -1

  ' spezielle Felder
  .hausX            = 4
  .hausY            = 9
  add .feldarbeiter(), .hausX, .hausY
  .anzFeldarbeiter = 1
  .garten(3).wert = 1
  
  ' allgemeine Einstellungen (bleiben immer gleich)
  .anzArbeiter = .anzFeldarbeiter + .anzMinenarbeiter + .anzSammler
  feld(.hausX, .hausY) = type<TypFeld>(Feldart.Haus, .typ)
  .gartenBerechnen
end with

with gegner
  .typ              = 5
  .suess            = &h7fffffff

  ' spezielle Felder
  .hausX            = 24
  .hausY            = 2
  add .feldarbeiter(), .hausX, .hausY
  .anzFeldarbeiter = 1
  .garten(1).wert = 3
  .garten(2).wert = 3
  
  ' allgemeine Einstellungen (bleiben immer gleich)
  .anzArbeiter = .anzFeldarbeiter + .anzMinenarbeiter + .anzSammler
  feld(.hausX, .hausY) = type<TypFeld>(Feldart.Haus, .typ)
  .gartenBerechnen
end with

' Feld zeichnen
for i as integer = 1 to FeldBreit
  for k as integer = 1 to FeldHoch
    hexfeld i, k, feld(i, k)
  next
next

' Spielfeld-Hintergrund sichern fuer die spaetere Darstellung
get (FeldXplus+10, 0)-step((FeldBreit+2)*HexRadius*3/2+HexXplus-11, (FeldHoch+2)*HexGroesse+HexYplus-1), hintergrund

steuerleiste opt
info opt

' Spielstart
dim zeit as double = timer
dim as integer schrittweite = 0, maus = 0, mx, my, mb
do
  if maus then
    ' Button wurde gedrueckt - wurde die Maustaste wieder losgelassen?
    getmouse mx, my,, mb
    if mb = 0 then maus = 0
  else
    ' Button gedrueckt? 
    select case pruefeButtons(opt)
      case 1
        ' Button "neuer Feldarbeiter"
        opt.anzFeldarbeiter += 1
        opt.anzArbeiter += 1
        add opt.feldarbeiter(), opt.hausX, opt.hausY
        maus = -1
        opt.suess -= 50
        info opt
        steuerleiste opt
      case 2
        ' Button "neuer Minenarbeiter"
        opt.anzMinenarbeiter += 1
        opt.anzArbeiter += 1
        ' TODO: vorlauefig festes Ziel
        add opt.minenarbeiter(), opt.hausX, opt.hausY, 20, 12
        maus = -1
        opt.suess -= 50
        info opt
        steuerleiste opt
      case 3
        ' Button "neuer Süßwarenjäger"
        opt.anzSammler += 1
        opt.anzArbeiter += 1
        ' TODO: vorlauefig festes Ziel
        add opt.sammler(), opt.hausX, opt.hausY, 24, 2
        maus = -1
        opt.suess -= 50
        info opt
        steuerleiste opt
      case 4
        ' Button "neuer Krieger"
        opt.anzKrieger += 1
        ' TODO: waehlbarer Start
        add opt.krieger(), opt.hausX, opt.hausY
        maus = -1
        opt.dollar -= 30
        info opt
        steuerleiste opt
      case 5
        ' Button "Falle produzieren"
      case 6
        ' Button "Falle postieren"
      case 7
        ' Button "Feld kaufen"
        dim as integer i
        for i = 1 to 18
          if opt.garten(i).wert = 0 then exit for
        next
        if i < 19 then
          opt.garten(i).wert = 1
          opt.suess -= 10
          opt.dollar -= 10
          opt.anzGarten += 1
        end if
        maus = -1
        info opt
        steuerleiste opt
    end select
  end if
  ' Zeitschritt
  if timer > zeit + Wartezeit then
    zeit = timer
    schrittweite += 1
    screenlock
    put (FeldXPlus+10, 0), hintergrund, pset
    zeichne opt, schrittweite
    zeichne gegner, schrittweite
    screenunlock
    if schrittweite = Schrittezahl then
      opt.suess -= opt.anzArbeiter
      schrittweite = 0
      opt.zeit -= 1
      ' Spielende (Zeit ueberschritten)
      if opt.zeit < 0 then
        draw string ((FeldBreit+2)*HexRadius*3/4+HexXplus+FeldXplus - 64, _
                     (((FeldHoch+2)*HexGroesse)\2 + HexYplus) - 4), "ZEIT ABGELAUFEN!"
        getkey
        end
      end if
      ' Feldarbeiter bewegen
      for i as integer = 1 to MaxFeldarbeiter
        with opt.feldarbeiter(i)
          select case .wert
            case 0 : continue for
            case Arbeiterwert.Daheim
              for i as integer = 1 to 18
                if opt.garten(i).wert = 1 then             ' Garten zum Bepflanzen
                  opt.garten(i).wert = 2
                  .zielX = opt.garten(i).x
                  .zielY = opt.garten(i).y
                  .wert = Arbeiterwert.LaufPflanzen + i-1
                  exit select
                end if
              next
              for i as integer = 1 to 18
                if opt.garten(i).wert = 22 then            ' Garten zum Ernten
                  opt.garten(i).wert = 23
                  .zielX = opt.garten(i).x
                  .zielY = opt.garten(i).y
                  .wert = Arbeiterwert.LaufErnten + i-1
                  exit for
                end if
              next
            case Arbeiterwert.LaufPflanzen to Arbeiterwert.LaufPflanzen+17
              if .x = .zielX and .y = .zielY then
                .warte = 0
                .zielX = opt.hausX
                .zielY = opt.hausY
                opt.garten(.wert-Arbeiterwert.LaufPflanzen+1).wert = 3
                .wert = Arbeiterwert.LaufHeim
              end if
            case Arbeiterwert.LaufErnten to Arbeiterwert.LaufErnten+17
              if .x = .zielX and .y = .zielY then
                .warte = 0
                .zielX = opt.hausX
                .zielY = opt.hausY
                opt.garten(.wert-Arbeiterwert.LaufErnten+1).wert = 1
                .wert = Arbeiterwert.LaufHeim
                opt.suess += 50
              end if
            case Arbeiterwert.LaufHeim
              if .x = .zielX and .y = .zielY then
                .warte = 1
                .wert  = Arbeiterwert.Daheim
              end if            
          end select
        end with
        opt.feldarbeiter(i).weiter
      next
      ' Minenarbeiter bewegen
      for i as integer = 1 to MaxMinenarbeiter
        with opt.minenarbeiter(i)
          select case .wert
            case 0 : continue for
            case Arbeiterwert.Daheim
              .wert = Arbeiterwert.LaufErnten
            case Arbeiterwert.LaufErnten
              if .x = .zielX and .y = .zielY then
                .warte = 3
                .zielX = opt.hausX
                .zielY = opt.hausY
                .wert = Arbeiterwert.LaufHeim
              end if
            case Arbeiterwert.LaufHeim
              if .x = .zielX and .y = .zielY then
                .warte = 1
                if opt.suess < 0 then
                  .wert = 0
                  opt.anzMinenarbeiter -= 1
                  opt.anzArbeiter -= 1
                else
                  .wert  = Arbeiterwert.LaufErnten
                  .zielX = .arbeitX
                  .zielY = .arbeitY
                end if
                opt.fuellAktuell += 1
                opt.dollar += 1
                if opt.fuellAktuell >= opt.fuellZiel then
                  info opt
                  draw string ((FeldBreit+2)*HexRadius*3/4+HexXplus+FeldXplus - 56, _
                               ((FeldHoch+2)*HexGroesse)\2 + HexYplus - 4), "ZIEL ERREICHT!"
                  getkey
                  end
                end if
              end if            
          end select
        end with
        opt.minenarbeiter(i).weiter
      next
      ' Suessigkeitenjaeger bewegen
      for i as integer = 1 to MaxSammler
        with opt.sammler(i)
          select case .wert
            case 0 : continue for
            case Arbeiterwert.Daheim
              .wert = Arbeiterwert.LaufErnten
            case Arbeiterwert.LaufErnten
              if .x = .zielX and .y = .zielY then
                .warte = 2
                .zielX = opt.hausX
                .zielY = opt.hausY
                if gegner.suess >= 30 then
                  .wert = Arbeiterwert.LaufHeim + 30
                  gegner.suess -= 30
                else
                  gegner.schaden += 30 - gegner.suess
                  .wert = Arbeiterwert.LaufHeim + gegner.suess
                  gegner.suess = 0
                end if
              end if
            case Arbeiterwert.LaufHeim to Arbeiterwert.LaufHeim + 30
              if .x = .zielX and .y = .zielY then
                .warte = 1
                opt.suess += .wert - Arbeiterwert.LaufHeim
                if opt.suess < 0 then
                  .wert = 0
                  opt.anzSammler -= 1
                  opt.anzArbeiter -= 1
                else
                  .wert  = Arbeiterwert.LaufErnten
                  .zielX = .arbeitX
                  .zielY = .arbeitY
                end if
              end if            
          end select
        end with
        opt.sammler(i).weiter
      next
      info opt
      steuerleiste opt
    end if    
  end if
  sleep 1
loop until len(inkey)
